searchNodes=[{"doc":"Welcome to AshAuthentication.Pheonix . The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy. Where to start. Presuming that you already have Phoenix , Ash and AshAuthentication installed and configured, start by adding plugs and routes to your router using AshAuthentication.Phoenix.Router and customising your sign-in page as needed. Customisation There are several methods of customisation available depending on the level of control you would like: Use the generic sign-in liveview - AshAuthentication.Phoenix.SignInLive . Apply overrides using AshAuthentication.Phoenix.Overrides to set your own CSS classes for all components. Build your own sign-in pages using the pre-defined components. Build your own sign-in pages using the generated auth routes.","ref":"AshAuthentication.Phoenix.html","title":"AshAuthentication.Phoenix","type":"module"},{"doc":"The authentication controller generator. Since authentication often requires explicit HTTP requests to do things like set cookies or return Authorization headers, use this module to create an AuthController in your Phoenix application. Example Handling the registration or authentication of a normal web-based user. defmodule MyAppWeb.AuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do conn |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : Routes . page_path ( conn , :index ) ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do conn |&gt; clear_session ( ) |&gt; render ( &quot;sign_out.html&quot; ) end end Handling registration or authentication of an API user. defmodule MyAppWeb.ApiAuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller alias AshAuthentication.TokenRevocation def success ( conn , _activity , _user , token ) do conn |&gt; put_status ( 200 ) |&gt; json ( %{ authentication : %{ status : :success , bearer : token } } ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; json ( %{ authentication : %{ status : :failed } } ) end def sign_out ( conn , _params ) do conn |&gt; revoke_bearer_tokens ( ) |&gt; json ( %{ status : :ok } ) end end","ref":"AshAuthentication.Phoenix.Controller.html","title":"AshAuthentication.Phoenix.Controller","type":"behaviour"},{"doc":"Called when authentication fails.","ref":"AshAuthentication.Phoenix.Controller.html#c:failure/3","title":"AshAuthentication.Phoenix.Controller.failure/3","type":"callback"},{"doc":"Called when a request to sign out is received.","ref":"AshAuthentication.Phoenix.Controller.html#c:sign_out/2","title":"AshAuthentication.Phoenix.Controller.sign_out/2","type":"callback"},{"doc":"Called when authentication (or registration, depending on the provider) has been successful.","ref":"AshAuthentication.Phoenix.Controller.html#c:success/4","title":"AshAuthentication.Phoenix.Controller.success/4","type":"callback"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:activity/0","title":"AshAuthentication.Phoenix.Controller.activity/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:t/0","title":"AshAuthentication.Phoenix.Controller.t/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:token/0","title":"AshAuthentication.Phoenix.Controller.token/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:user/0","title":"AshAuthentication.Phoenix.Controller.user/0","type":"type"},{"doc":"Helper plugs mixed in to your router. When you use AshAuthentication.Phoenix.Router this module is included, so that you can use these plugs in your pipelines.","ref":"AshAuthentication.Phoenix.Plug.html","title":"AshAuthentication.Phoenix.Plug","type":"module"},{"doc":"Attempt to retrieve actors from the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_bearer/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_bearer/2","title":"AshAuthentication.Phoenix.Plug.load_from_bearer/2","type":"function"},{"doc":"Attempt to retrieve all actors from the connections' session. A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_session/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_session/2","title":"AshAuthentication.Phoenix.Plug.load_from_session/2","type":"function"},{"doc":"Revoke all token(s) in the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.revoke_bearer_tokens/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#revoke_bearer_tokens/2","title":"AshAuthentication.Phoenix.Plug.revoke_bearer_tokens/2","type":"function"},{"doc":"Store the actor in the connections' session.","ref":"AshAuthentication.Phoenix.Plug.html#store_in_session/2","title":"AshAuthentication.Phoenix.Plug.store_in_session/2","type":"function"},{"doc":"Phoenix route generation for AshAuthentication. Using this module imports the macros in this module and the plug functions from AshAuthentication.Phoenix.Plug . Usage Adding authentication to your live-view router is very simple: defmodule MyAppWeb.Router do use MyAppWeb , :router use AshAuthentication.Phoenix.Router pipeline :browser do # ... plug ( :load_from_session ) end pipeline :api do # ... plug ( :load_from_bearer ) end scope &quot;/&quot; , MyAppWeb do pipe_through :browser sign_in_route sign_out_route AuthController auth_routes_for MyApp.Accounts.User , to : AuthController reset_route end","ref":"AshAuthentication.Phoenix.Router.html","title":"AshAuthentication.Phoenix.Router","type":"module"},{"doc":"Generates the routes needed for the various strategies for a given AshAuthentication resource. This is required if you wish to use authentication. Options to - a module which implements the AshAuthentication.Phoenix.Controller behaviour. This is required. path - a string (starting with &quot;/&quot;) wherein to mount the generated routes. scope_opts - any options to pass to the generated scope. Example scope &quot;/&quot; , DevWeb do auth_routes_for ( MyApp.Accounts.User , to : AuthController , path : &quot;/authentication&quot; , scope_opts : [ host : &quot;auth.example.com&quot; ] ) end","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2","title":"AshAuthentication.Phoenix.Router.auth_routes_for/2","type":"macro"},{"doc":"Generates a generic, white-label password reset page using LiveView and the components in AshAuthentication.Phoenix.Components . Available options are: path the path under which to mount the live-view. Defaults to &quot;/password-reset&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.ResetLive . as which is passed to the generated live route. Defaults to :auth . overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope . This is completely optional.","ref":"AshAuthentication.Phoenix.Router.html#reset_route/1","title":"AshAuthentication.Phoenix.Router.reset_route/1","type":"macro"},{"doc":"Generates a generic, white-label sign-in page using LiveView and the components in AshAuthentication.Phoenix.Components . This is completely optional. Available options are: path the path under which to mount the live-view. Defaults to &quot;/sign-in&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.SignInLive . as which is passed to the generated live route. Defaults to :auth . overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope .","ref":"AshAuthentication.Phoenix.Router.html#sign_in_route/1","title":"AshAuthentication.Phoenix.Router.sign_in_route/1","type":"macro"},{"doc":"Generates a sign-out route which points to the sign_out action in your auth controller. This is optional, but you probably want it.","ref":"AshAuthentication.Phoenix.Router.html#sign_out_route/3","title":"AshAuthentication.Phoenix.Router.sign_out_route/3","type":"macro"},{"doc":"Options that can be passed to auth_routes_for .","ref":"AshAuthentication.Phoenix.Router.html#t:auth_route_options/0","title":"AshAuthentication.Phoenix.Router.auth_route_options/0","type":"type"},{"doc":"A sub-path if required. Defaults to /auth .","ref":"AshAuthentication.Phoenix.Router.html#t:path_option/0","title":"AshAuthentication.Phoenix.Router.path_option/0","type":"type"},{"doc":"Any options which should be passed to the generated scope.","ref":"AshAuthentication.Phoenix.Router.html#t:scope_opts_option/0","title":"AshAuthentication.Phoenix.Router.scope_opts_option/0","type":"type"},{"doc":"The controller which will handle success and failure.","ref":"AshAuthentication.Phoenix.Router.html#t:to_option/0","title":"AshAuthentication.Phoenix.Router.to_option/0","type":"type"},{"doc":"Behaviour for overriding component styles and attributes in your application. The default implementation is AshAuthentication.Phoenix.Overrides.Default which uses TailwindCSS to generate a fairly generic looking user interface. You can override this by adding your own override modules to the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router: sign_in_route overrides : [ MyAppWeb.AuthOverrides , AshAuthentication.Phoenix.Overrides.Default ] and defining lib/my_app_web/auth_overrides.ex within which you can set any overrides. The use macro defines overridable versions of all callbacks which return nil , so you only need to define the functions that you care about. Each of the override modules specified in the config will be called in the order that they're specified, so you can still use the defaults if you just override some properties. defmodule MyAppWeb.AuthOverrides do use AshAuthentication.Phoenix.Overrides alias AshAuthentication.Phoenix.Components override Components.Banner do set :image_url , &quot;/images/sign_in_logo.png&quot; end end","ref":"AshAuthentication.Phoenix.Overrides.html","title":"AshAuthentication.Phoenix.Overrides","type":"module"},{"doc":"Define overrides for a specific component.","ref":"AshAuthentication.Phoenix.Overrides.html#override/2","title":"AshAuthentication.Phoenix.Overrides.override/2","type":"macro"},{"doc":"Override a setting within a component.","ref":"AshAuthentication.Phoenix.Overrides.html#set/2","title":"AshAuthentication.Phoenix.Overrides.set/2","type":"macro"},{"doc":"This is the default overrides for our component UI. The CSS styles are based on TailwindCSS .","ref":"AshAuthentication.Phoenix.Overrides.Default.html","title":"AshAuthentication.Phoenix.Overrides.Default","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Overrides.Default.html#overrides/0","title":"AshAuthentication.Phoenix.Overrides.Default.overrides/0","type":"function"},{"doc":"Generates a sign-in button for OAuth2. Component heirarchy This is the top-most provider specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :link_class - CSS classes for the a element. :root_class - CSS classes for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.OAuth2.html","title":"AshAuthentication.Phoenix.Components.OAuth2","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#t:props/0","title":"AshAuthentication.Phoenix.Components.OAuth2.props/0","type":"type"},{"doc":"Generates sign in, registration and reset forms for a resource. Component hierarchy This is the top-most provider-specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Children: AshAuthentication.Phoenix.Components.Password.SignInForm AshAuthentication.Phoenix.Components.Password.RegisterForm AshAuthentication.Phoenix.Components.Password.ResetForm Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :hide_class - CSS class to apply to hide an element. :interstitial_class - CSS class for the div element between the form and the button. :register_toggle_text - Toggle text to display when the register form is not showing. :reset_toggle_text - Toggle text to display when the reset form is not showing. :root_class - CSS class for the root div element. :show_first - The form to show on first load. Either :sign_in or :register . :sign_in_toggle_text - Toggle text to display when the sign in form is not showing. :toggler_class - CSS class for the toggler a element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.html","title":"AshAuthentication.Phoenix.Components.Password","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.props/0","type":"type"},{"doc":"Function components for dealing with form input during password authentication. Component hierarchy These function components are consumed by AshAuthentication.Phoenix.Components.Password.SignInForm , AshAuthentication.Phoenix.Components.Password.RegisterForm and AshAuthentication.Phoenix.Components.ResetForm . Overrides This component provides the following overrides: :error_li - CSS class for the li elements on error lists. :error_ul - CSS class for the ul element on error lists. :field_class - CSS class for div elements surrounding the fields. :input_class - CSS class for text/password input elements. :input_class_with_error - CSS class for text/password input elements when there is a validation error. :input_debounce - Number of milliseconds to debounce input by (or nil to disable). :label_class - CSS class for label elements. :submit_class - CSS class for the form submit input element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html","title":"AshAuthentication.Phoenix.Components.Password.Input","type":"module"},{"doc":"Generate a list of errors for a field (if there are any). Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. form - An AshPhoenix.Form . Required. field - The field for which to retrieve the errors. Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#error/1","title":"AshAuthentication.Phoenix.Components.Password.Input.error/1","type":"function"},{"doc":"Generate a form field for the configured identity field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. input_type - Either :text or :email . If not set it will try and guess based on the name of the identity field. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#identity_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.identity_field/1","type":"function"},{"doc":"Generate a form field for the configured password confirmation entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_confirmation_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1","type":"function"},{"doc":"Generate a form field for the configured password entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_field/1","type":"function"},{"doc":"Generate an form submit button. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. action - Either :sign_in or :register . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#submit/1","title":"AshAuthentication.Phoenix.Components.Password.Input.submit/1","type":"function"},{"doc":"Generates a default registration form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. socket - Needed to infer the otp-app from the Phoenix endpoint. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm.props/0","type":"type"},{"doc":"Generates a default sign in form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html","title":"AshAuthentication.Phoenix.Components.Password.SignInForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.SignInForm.props/0","type":"type"},{"doc":"Renders sign in mark-up for an authenticated resource. This means that it will render sign-in UI for all of the authentication strategies for a resource. For each strategy configured on the resource a component name is inferred (e.g. AshAuthentication.Strategy.Password becomes AshAuthentication.Phoenix.Components.Strategy.Passowrd ) and is rendered into the output. Component hierarchy This is the top-most authentication component. Children: AshAuthentication.Phoenix.Components.Strategy.Password . AshAuthentication.Phoenix.Components.Strategy.OAuth2 . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information. Props overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.SignIn.html","title":"AshAuthentication.Phoenix.Components.SignIn","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.SignIn.html#t:props/0","title":"AshAuthentication.Phoenix.Components.SignIn.props/0","type":"type"},{"doc":"A generic, white-label sign-in page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view finds all Ash resources with an authentication configuration (via AshAuthentication.authenticated_resources/1 ) and renders the appropriate UI for their providers using AshAuthentication.Phoenix.Components.SignIn . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :sign_in_id - Element ID for the SignIn LiveComponent. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.SignInLive.html","title":"AshAuthentication.Phoenix.SignInLive","type":"module"},{"doc":"Renders a very simple banner at the top of the sign-in component. Can show either an image or some text, depending on the provided overrides. Overrides This component provides the following overrides: :href_class - CSS class for the a tag. :href_url - A URL for the banner image to link to. Set to nil to disable. :image_class - CSS class for the img tag. :image_url - A URL for the img src attribute. Set to nil to disable. :root_class - CSS class for the root div element. :text - Banner text. Set to nil to disable. :text_class - CSS class for the text div . See AshAuthentication.Phoenix.Overrides for more information. ## Props * ` overrides ` - A list of override modules .","ref":"AshAuthentication.Phoenix.Components.Banner.html","title":"AshAuthentication.Phoenix.Components.Banner","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Banner.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Banner.props/0","type":"type"},{"doc":"Helpers which are commonly needed inside the various components.","ref":"AshAuthentication.Phoenix.Components.Helpers.html","title":"AshAuthentication.Phoenix.Components.Helpers","type":"module"},{"doc":"The LiveView Socket contains a reference to the Phoenix endpoint, and from there we can extract the otp_app of the current request.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#otp_app_from_socket/1","title":"AshAuthentication.Phoenix.Components.Helpers.otp_app_from_socket/1","type":"function"},{"doc":"The LiveView Socket contains a refererence to the Phoenix router, and from there we can generate the name of the route helpers module.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#route_helpers/1","title":"AshAuthentication.Phoenix.Components.Helpers.route_helpers/1","type":"function"},{"doc":"A horizontal rule with text. This component is pretty tailwind-specific, but I (@jimsynz) really wanted a certain look. If you think I'm wrong then please let me know. Overrides This component provides the following overrides: :hr_inner_class - CSS class for the inner div element of the horizontal rule. :hr_outer_class - CSS class for the outer div element of the horizontal rule. :root_class - CSS class for the root div element. :text - Text to display in front of the horizontal rule. :text_inner_class - CSS class for the inner div element of the text area. :text_outer_class - CSS class for the outer div element of the text area. See AshAuthentication.Phoenix.Overrides for more information. Props * ` overrides ` - A list of override modules .","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html","title":"AshAuthentication.Phoenix.Components.HorizontalRule","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#t:props/0","title":"AshAuthentication.Phoenix.Components.HorizontalRule.props/0","type":"type"},{"doc":"Generates a default password reset form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :reset_flash_text - Text for the flash message when a request is received. Set to nil to disable. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html","title":"AshAuthentication.Phoenix.Components.Password.ResetForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.ResetForm.props/0","type":"type"},{"doc":"Renders a password-reset form. Component heirarchy Children: AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props token - The reset token. overrides - A list of override modules. Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.html","title":"AshAuthentication.Phoenix.Components.Reset","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.props/0","type":"type"},{"doc":"Generates a default password reset form. Component heirarchy This is a child of AshAuthentication.Phoenix.Components.Reset . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 AshAuthentication.Phoenix.Components.Password.Input.error/1 Props token - The reset token. socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :spacer_class - CSS classes for space between the password input and submit elements. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html","title":"AshAuthentication.Phoenix.Components.Reset.Form","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.Form.props/0","type":"type"},{"doc":"Auto generates documentation and helpers for components.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html","title":"AshAuthentication.Phoenix.Overrides.Overridable","type":"module"},{"doc":"Retrieve configuration for a potentially overriden value.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#override_for/3","title":"AshAuthentication.Phoenix.Overrides.Overridable.override_for/3","type":"macro"},{"doc":"A generic, white-label password reset page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.reset_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view looks for the token URL parameter, and if found passes it to AshAuthentication.Phoenix.Components.Reset . Overrides This component provides the following overrides: :reset_id - Element ID for the Reset LiveComponent. :root_class - CSS class for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.ResetLive.html","title":"AshAuthentication.Phoenix.ResetLive","type":"module"},{"doc":"The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy.","ref":"readme.html","title":"AshAuthentication.Phoenix","type":"extras"},{"doc":"This is beta software. Please don't use it without talking to us!","ref":"readme.html#warning","title":"AshAuthentication.Phoenix - Warning","type":"extras"},{"doc":"The package can be installed by adding ash_authentication_phoenix to your list of dependencies in mix.exs : def deps do [ { :ash_authentication_phoenix , &quot;~&gt; 1.2.0&quot; } ] end If you wish to use our default Tailwind -based components, you will need to add the path to ash_authentication_phoenix 's components in your assets/tailwind.config.js : module.exports = { content: [ // Other paths. &quot;../deps/ash_authentication_phoenix/**/*.ex&quot; ] }","ref":"readme.html#installation","title":"AshAuthentication.Phoenix - Installation","type":"extras"},{"doc":"This package assumes that you have Phoenix , Ash and AshAuthentication installed and configured. See their individual documentation for details. This package is designed so that you can choose the level of customisation required. At the easiest level of configuration, you can just add the routes into your router: defmodule MyAppWeb.Router do use MyAppWeb , :router use AshAuthentication.Phoenix.Router pipeline :browser do # ... plug ( :load_from_session ) end scope &quot;/&quot; do pipe_through :browser sign_in_route sign_out_route MyAppWeb.AuthController auth_routes_for MyApp.Accounts.User , to : MyAppWeb.AuthController end end This will give you a generic sign-in/registration page and store the authenticated user in the Phoenix session. Customisation There are several methods of customisation available depending on the level of control you would like: Use the generic sign-in liveview . Apply overrides to set your own CSS classes for all components. Build your own sign-in pages using the pre-defined components. Build your own sign-in pages using the generated auth routes.","ref":"readme.html#usage","title":"AshAuthentication.Phoenix - Usage","type":"extras"},{"doc":"Documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"AshAuthentication.Phoenix - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on out GitHub discussions page .","ref":"readme.html#contributing","title":"AshAuthentication.Phoenix - Contributing","type":"extras"},{"doc":"MIT","ref":"readme.html#licence","title":"AshAuthentication.Phoenix - Licence","type":"extras"}]